﻿using System;
using ICallisto;

namespace CallistoX
{
    class HelpMessages
    {
        public static void FilterHelp(IUser userobj)
        {
            Callisto.Print(userobj, "\x000314\x0007file filtering");
            Callisto.Print(userobj, String.Empty);
            Callisto.Print(userobj, "\x000314#addfilefilter <trigger>, <type>[, <args>]     add a new file filter");
            Callisto.Print(userobj, "\x000314#remfilefilter <filter_id>     remove a file filter");
            Callisto.Print(userobj, "\x000314#filefilters     list all file filters");
            Callisto.Print(userobj, String.Empty);
            Callisto.Print(userobj, "\x000314\x0006kill\x0006 ->  disconnect a user with trigger word in a filename");
            Callisto.Print(userobj, "\x000314\x0006ban\x0006 ->  ban a user with trigger word in a filename");
            Callisto.Print(userobj, "\x000314\x0006announce\x0006  ->  pm a user with trigger word in a filename [+f +n +ip]");
            Callisto.Print(userobj, "\x000314\x0006clone\x0006  ->  pm a user with trigger word in a filename [+f +n +ip]");
            Callisto.Print(userobj, String.Empty);
            Callisto.Print(userobj, "\x000314\x0007word filtering");
            Callisto.Print(userobj, String.Empty);
            Callisto.Print(userobj, "\x000314#addwordfilter <trigger>, <type>[, <args>]     add a new word filter");
            Callisto.Print(userobj, "\x000314#remwordfilter <filter_id>     remove a word filter");
            Callisto.Print(userobj, "\x000314#wordfilters     list all word filters");
            Callisto.Print(userobj, "\x000314#addline <filter_id>, <args>     add line to announce filter");
            Callisto.Print(userobj, "\x000314#remline <filter_id>, <line_id>     remove line from announce filter");
            Callisto.Print(userobj, "\x000314#editline <filter_id>, <line_id>, <args>     edit line in announce filter");
            Callisto.Print(userobj, "\x000314#viewfilter <filter_id>     view an announce filter");
            Callisto.Print(userobj, String.Empty);
            Callisto.Print(userobj, "\x000314\x0006muzzle\x0006  ->  muzzle a user for typing a trigger word");
            Callisto.Print(userobj, "\x000314\x0006kiddy\x0006  ->  kiddy a user for typing a trigger word");
            Callisto.Print(userobj, "\x000314\x0006kill\x0006  ->  disconnect a user for typing a trigger word");
            Callisto.Print(userobj, "\x000314\x0006ban\x0006  ->  ban a user for typing a trigger word");
            Callisto.Print(userobj, "\x000314\x0006censor\x0006  ->  censor a user for typing a trigger word");
            Callisto.Print(userobj, "\x000314\x0006move\x0006  ->  move a user to a vroom for typing a trigger word");
            Callisto.Print(userobj, "\x000314\x0006redirect\x0006  ->  redirect a user for typing a trigger word");
            Callisto.Print(userobj, "\x000314\x0006pm\x0006  ->  pm a user for typing a trigger word [+n +ip]");
            Callisto.Print(userobj, "\x000314\x0006announce\x0006  ->  print announcement by typing a trigger word [+n +ip +r]");
            Callisto.Print(userobj, "\x000314\x0006clone\x0006  ->  clone a user for typing a trigger word [+n +ip]");
            Callisto.Print(userobj, "\x000314\x0006replace\x0006  ->  word replacement");
            Callisto.Print(userobj, String.Empty);
            Callisto.Print(userobj, "\x000314\x0007join filtering");
            Callisto.Print(userobj, String.Empty);
            Callisto.Print(userobj, "\x000314#addjoinfilter <trigger>, <type>[, <args>]     add a new join filter");
            Callisto.Print(userobj, "\x000314#remjoinfilter <filter_id>     remove a join filter");
            Callisto.Print(userobj, "\x000314#joinfilters     list all join filters");
            Callisto.Print(userobj, String.Empty);
            Callisto.Print(userobj, "\x000314\x0006censor\x0006  ->  remove censored characters from usernames");
            Callisto.Print(userobj, "\x000314\x0006vspy\x0006  ->  user added to vspy if name or ip includes trigger");
            Callisto.Print(userobj, "\x000314\x0006antiflood\x0006  ->  user does not flood out if ip matches trigger");
            Callisto.Print(userobj, "\x000314\x0006ipsend\x0006  ->  user added to ipsend if name or ip includes trigger");
            Callisto.Print(userobj, "\x000314\x0006logsend\x0006  ->  user added to logsend if name or ip includes trigger");
            Callisto.Print(userobj, "\x000314\x0006bansend\x0006  ->  user added to bansend if name or ip includes trigger");
            Callisto.Print(userobj, "\x000314\x0006portban\x0006  ->  reject user if port matches trigger");
            Callisto.Print(userobj, "\x000314\x0006ipban\x0006  ->  reject user if ip starts with trigger");
            Callisto.Print(userobj, "\x000314\x0006nameban\x0006  ->  reject user if name includes trigger");
            Callisto.Print(userobj, "\x000314\x0006move\x0006  ->  move user to a vroom if name or ip includes trigger");
            Callisto.Print(userobj, "\x000314\x0006redirect\x0006  ->  redirect user if name or ip includes trigger");
            Callisto.Print(userobj, "\x000314\x0006pm\x0006  ->  pm a user if name or ip includes trigger [+n +ip]");
            Callisto.Print(userobj, "\x000314\x0006announce\x0006  ->  print announcement if name or ip includes trigger [+n +ip]");
            Callisto.Print(userobj, "\x000314\x0006clone\x0006  ->  clone a user if name or ip includes trigger [+n +ip]");
            Callisto.Print(userobj, "\x000314\x0006changename\x0006  ->  change user's name if name or ip includes trigger");
            Callisto.Print(userobj, "\x000314\x0006reservename\x0006  ->  only allow matching ip to use a username");
            Callisto.Print(userobj, "\x000314\x0006disableavatar\x0006  ->  stop user from uploading an avatar");
            Callisto.Print(userobj, "\x000314\x0006age\x0006  ->  set a new age for a user");
            Callisto.Print(userobj, String.Empty);
            Callisto.Print(userobj, "\x000314\x0007pm filtering");
            Callisto.Print(userobj, String.Empty);
            Callisto.Print(userobj, "\x000314#addpmfilter <trigger>, <type>     add a new pm filter");
            Callisto.Print(userobj, "\x000314#rempmfilter <filter_id>     remove a pm filter");
            Callisto.Print(userobj, "\x000314#pmfilters     list all pm filters");
            Callisto.Print(userobj, String.Empty);
            Callisto.Print(userobj, "\x000314\x0006kill\x0006  ->  disconnect a user for typing a trigger word");
            Callisto.Print(userobj, "\x000314\x0006ban\x0006  ->  ban a user for typing a trigger word");
            Callisto.Print(userobj, "\x000314\x0006censor\x0006  ->  censor a user for typing a trigger word");
            Callisto.Print(userobj, String.Empty);
            Callisto.Print(userobj, "\x000314\x0007identifiers");
            Callisto.Print(userobj, String.Empty);
            Callisto.Print(userobj, "\x000314\x0006+n\x0006  ->  name");
            Callisto.Print(userobj, "\x000314\x0006+ip\x0006  ->  ip address");
            Callisto.Print(userobj, "\x000314\x0006+f\x0006  ->  filename");
            Callisto.Print(userobj, "\x000314\x0006+r\x0006  ->  remaining text");
        }

        public static void PrintHelp(IUser userobj)
        {
            Callisto.Print(userobj, String.Empty);
            Callisto.Print(userobj, "\x000314#pmblock <on or off>    pm blocking");
            Callisto.Print(userobj, "\x000314#info    view userlist information");
            Callisto.Print(userobj, "\x000314#pminfo     view userlist information");
            Callisto.Print(userobj, "\x000314#linkhash     view linked room hashlink");
            Callisto.Print(userobj, "\x000314#id     view your user ident");

            if (Settings.GeneralOn || userobj.Level > AdminLevel.Regular)
            {
                Callisto.Print(userobj, "\x000314#customname <user_id> <text>     set custom name");
                Callisto.Print(userobj, "\x000314#uncustomname <user_id>     unset custom name");
                Callisto.Print(userobj, "\x000314#vroom <number>     change vroom");
                Callisto.Print(userobj, "\x000314#google <query>     print google link");
                Callisto.Print(userobj, "\x000314#whisper <user_id> <message>     send a secret message");
                Callisto.Print(userobj, "\x000314#locate     discover users in vrooms");
                Callisto.Print(userobj, "\x000314#viewmotd     print the motd");
            }

            if (userobj.Level > AdminLevel.Regular)
            {
                Callisto.Print(userobj, "\x000314#filterhelp    view filter commands and types");

                if (userobj.Level >= CmdLevelManager.GetLevel(Cmd.enableavatar))
                    Callisto.Print(userobj, "\x000314#enableavatar <user_id>    allow user to upload an avatar");
                if (userobj.Level >= CmdLevelManager.GetLevel(Cmd.disableavatar))
                    Callisto.Print(userobj, "\x000314#disableavatar <user_id>    stop user from uploading an avatar");
                if (userobj.Level >= CmdLevelManager.GetLevel(Cmd.clearscreen))
                    Callisto.Print(userobj, "\x000314#clearscreen     clear vroom screen");
                if (userobj.Level >= CmdLevelManager.GetLevel(Cmd.cloak))
                    Callisto.Print(userobj, "\x000314#cloak <on or off>     hide from the userlist");
                if (userobj.Level >= CmdLevelManager.GetLevel(Cmd.muzzle))
                    Callisto.Print(userobj, "\x000314#muzzle <user_id> [<reason>]     muzzle a user");
                if (userobj.Level >= CmdLevelManager.GetLevel(Cmd.unmuzzle))
                    Callisto.Print(userobj, "\x000314#unmuzzle <user_id> [<reason>]     unmuzzle a user");
                if (userobj.Level >= CmdLevelManager.GetLevel(Cmd.kill))
                    Callisto.Print(userobj, "\x000314#kill <user_id> [<reason>]     disconnect a user");
                if (userobj.Level >= CmdLevelManager.GetLevel(Cmd.ban))
                    Callisto.Print(userobj, "\x000314#ban <user_id> [<reason>]     ban a user");
                if (userobj.Level >= CmdLevelManager.GetLevel(Cmd.unban))
                    Callisto.Print(userobj, "\x000314#unban <ban_id or \"name\">     unban a user");
                if (userobj.Level >= CmdLevelManager.GetLevel(Cmd.listbans))
                    Callisto.Print(userobj, "\x000314#listbans     list all bans");
                if (userobj.Level >= CmdLevelManager.GetLevel(Cmd.rangeban))
                    Callisto.Print(userobj, "\x000314#rangeban <ip>     ban users from an ip range");
                if (userobj.Level >= CmdLevelManager.GetLevel(Cmd.rangeunban))
                    Callisto.Print(userobj, "\x000314#rangeunban <ban_id or \"ip\">     unban an ip range");
                if (userobj.Level >= CmdLevelManager.GetLevel(Cmd.listrangebans))
                    Callisto.Print(userobj, "\x000314#listrangebans     list all range bans");
                if (userobj.Level >= CmdLevelManager.GetLevel(Cmd.kiddy))
                    Callisto.Print(userobj, "\x000314#kiddy <user_id> [<reason>]     force pink text");
                if (userobj.Level >= CmdLevelManager.GetLevel(Cmd.unkiddy))
                    Callisto.Print(userobj, "\x000314#unkiddy <user_id> [<reason>]     unforce pink text");
                if (userobj.Level >= CmdLevelManager.GetLevel(Cmd.paint))
                    Callisto.Print(userobj, "\x000314#paint <user_id> <text>     add prefix to text");
                if (userobj.Level >= CmdLevelManager.GetLevel(Cmd.unpaint))
                    Callisto.Print(userobj, "\x000314#unpaint <user_id>     remove paint");
                if (userobj.Level >= CmdLevelManager.GetLevel(Cmd.echo))
                    Callisto.Print(userobj, "\x000314#echo <user_id> <text>     add echo text");
                if (userobj.Level >= CmdLevelManager.GetLevel(Cmd.unecho))
                    Callisto.Print(userobj, "\x000314#unecho <user_id>     remove echo text");
                if (userobj.Level >= CmdLevelManager.GetLevel(Cmd.lower))
                    Callisto.Print(userobj, "\x000314#lower <user_id> [<reason>]     force lower case");
                if (userobj.Level >= CmdLevelManager.GetLevel(Cmd.unlower))
                    Callisto.Print(userobj, "\x000314#unlower <user_id> [<reason>]     unforce lower case");
                if (userobj.Level >= CmdLevelManager.GetLevel(Cmd.redirect))
                    Callisto.Print(userobj, "\x000314#redirect <user_id> <hashlink>     send user to a room");
                if (userobj.Level >= CmdLevelManager.GetLevel(Cmd.clone))
                    Callisto.Print(userobj, "\x000314#clone <user_id> <text>     clone a user");
                if (userobj.Level >= CmdLevelManager.GetLevel(Cmd.changename))
                    Callisto.Print(userobj, "\x000314#changename <user_id> <name>    change a user name");
                if (userobj.Level >= CmdLevelManager.GetLevel(Cmd.oldname))
                    Callisto.Print(userobj, "\x000314#oldname <user_id>     restore a user name");
                if (userobj.Level >= CmdLevelManager.GetLevel(Cmd.urban))
                    Callisto.Print(userobj, "\x000314#urban <query>    get urban definition");
                if (userobj.Level >= CmdLevelManager.GetLevel(Cmd.define))
                    Callisto.Print(userobj, "\x000314#define <query>     get dictionary definition");
                if (userobj.Level >= CmdLevelManager.GetLevel(Cmd.weather))
                    Callisto.Print(userobj, "\x000314#weather <user_id>     get weather report for user");
                if (userobj.Level >= CmdLevelManager.GetLevel(Cmd.customnames))
                    Callisto.Print(userobj, "\x000314#customnames     list all custom names");
                if (userobj.Level >= CmdLevelManager.GetLevel(Cmd.customnames))
                    Callisto.Print(userobj, "\x000314#customnames <on or off>     enable/disable custom names");
                if (userobj.Level >= CmdLevelManager.GetLevel(Cmd.general))
                    Callisto.Print(userobj, "\x000314#general <on or off>     enable/disable general commands");
                if (userobj.Level >= CmdLevelManager.GetLevel(Cmd.caps))
                    Callisto.Print(userobj, "\x000314#caps <on or off>     enable/disable caps monitoring");
                if (userobj.Level >= CmdLevelManager.GetLevel(Cmd.colors))
                    Callisto.Print(userobj, "\x000314#colors <on or off>     enable/disable color text");
                if (userobj.Level >= CmdLevelManager.GetLevel(Cmd.lastseen))
                    Callisto.Print(userobj, "\x000314#lastseen <on or off>     enable/disable last seen monitoring");
                if (userobj.Level >= CmdLevelManager.GetLevel(Cmd.sharefiles))
                    Callisto.Print(userobj, "\x000314#sharefiles <on or off>     enable/disable share file monitoring");
                if (userobj.Level >= CmdLevelManager.GetLevel(Cmd.anon))
                    Callisto.Print(userobj, "\x000314#anon <on or off>     enable/disable anon monitoring");
                if (userobj.Level >= CmdLevelManager.GetLevel(Cmd.idle))
                    Callisto.Print(userobj, "\x000314#idle <on or off>     enable/disable idle monitoring");
                if (userobj.Level >= CmdLevelManager.GetLevel(Cmd.adminannounce))
                    Callisto.Print(userobj, "\x000314#adminannounce <on or off>     enable/disable admin only announce filters");
                if (userobj.Level >= CmdLevelManager.GetLevel(Cmd.shout))
                    Callisto.Print(userobj, "\x000314#shout <message>     send a message to all users");
                if (userobj.Level >= CmdLevelManager.GetLevel(Cmd.announce))
                    Callisto.Print(userobj, "\x000314#announce <text>     send an announcement to vroom");
                if (userobj.Level >= CmdLevelManager.GetLevel(Cmd.move))
                    Callisto.Print(userobj, "\x000314#move <user_id> <vroom>     send a user to a vroom");
                if (userobj.Level >= CmdLevelManager.GetLevel(Cmd.admins))
                    Callisto.Print(userobj, "\x000314#admins     print admin list");
                if (userobj.Level >= CmdLevelManager.GetLevel(Cmd.adminmsg))
                    Callisto.Print(userobj, "\x000314#adminmsg <message>     send message to admins");
                if (userobj.Level >= CmdLevelManager.GetLevel(Cmd.stats))
                    Callisto.Print(userobj, "\x000314#stats     show session stats");
                if (userobj.Level >= CmdLevelManager.GetLevel(Cmd.whois))
                    Callisto.Print(userobj, "\x000314#whois <user_id>     show user info");
                if (userobj.Level >= CmdLevelManager.GetLevel(Cmd.whowas))
                    Callisto.Print(userobj, "\x000314#whowas <name or ip>     check for records");
                if (userobj.Level >= CmdLevelManager.GetLevel(Cmd.trace))
                    Callisto.Print(userobj, "\x000314#trace <user_id or ip>");
                if (userobj.Level >= CmdLevelManager.GetLevel(Cmd.roomsearch))
                    Callisto.Print(userobj, "\x000314#roomsearch <query>     get room information");
                if (userobj.Level >= CmdLevelManager.GetLevel(Cmd.mtimeout))
                    Callisto.Print(userobj, "\x000314#mtimeout <0 to 90> muzzle timeout minutes");
                if (userobj.Level >= CmdLevelManager.GetLevel(Cmd.clock))
                    Callisto.Print(userobj, "\x000314#clock <on or off>     show clock in topic");
                if (userobj.Level >= CmdLevelManager.GetLevel(Cmd.bansend))
                    Callisto.Print(userobj, "\x000314#bansend <on or off>     show rejected users");
                if (userobj.Level >= CmdLevelManager.GetLevel(Cmd.logsend))
                    Callisto.Print(userobj, "\x000314#logsend <on or off>     show admin log");
                if (userobj.Level >= CmdLevelManager.GetLevel(Cmd.stealth))
                    Callisto.Print(userobj, "\x000314#stealth <on or off>     hide admin commands");
                if (userobj.Level >= CmdLevelManager.GetLevel(Cmd.ipsend))
                    Callisto.Print(userobj, "\x000314#ipsend <on or off>     show joining user ip");
                if (userobj.Level >= CmdLevelManager.GetLevel(Cmd.topic))
                    Callisto.Print(userobj, "\x000314#topic <text>     set topic for this vroom");
                if (userobj.Level >= CmdLevelManager.GetLevel(Cmd.url))
                    Callisto.Print(userobj, "\x000314#url <on or off>     enable/disable url");
                if (userobj.Level >= CmdLevelManager.GetLevel(Cmd.addurl))
                    Callisto.Print(userobj, "\x000314#addurl <address> <text>     add new url");
                if (userobj.Level >= CmdLevelManager.GetLevel(Cmd.remurl))
                    Callisto.Print(userobj, "\x000314#remurl <url_id>     remove a url");
                if (userobj.Level >= CmdLevelManager.GetLevel(Cmd.listurl))
                    Callisto.Print(userobj, "\x000314#listurl     list the urls");
                if (userobj.Level >= CmdLevelManager.GetLevel(Cmd.greetmsg))
                    Callisto.Print(userobj, "\x000314#greetmsg <on or off>     enable/disable greet messages");
                if (userobj.Level >= CmdLevelManager.GetLevel(Cmd.addgreetmsg))
                    Callisto.Print(userobj, "\x000314#addgreetmsg <text>     add greet message");
                if (userobj.Level >= CmdLevelManager.GetLevel(Cmd.remgreetmsg))
                    Callisto.Print(userobj, "\x000314#remgreetmsg <greet_id>     remove greet message");
                if (userobj.Level >= CmdLevelManager.GetLevel(Cmd.listgreetmsg))
                    Callisto.Print(userobj, "\x000314#listgreetmsg     list the greet messages");
                if (userobj.Level >= CmdLevelManager.GetLevel(Cmd.pmgreetmsg))
                    Callisto.Print(userobj, "\x000314#pmgreetmsg <on or off>     enable/disable pm greet message");
                if (userobj.Level >= CmdLevelManager.GetLevel(Cmd.setpmgreetmsg))
                    Callisto.Print(userobj, "\x000314#setpmgreetmsg <text>     set the pm message");
                if (userobj.Level >= CmdLevelManager.GetLevel(Cmd.vspy))
                    Callisto.Print(userobj, "\x000314#vspy <on or off>     enable/disable vspy");
                if (userobj.Level >= CmdLevelManager.GetLevel(Cmd.listlang))
                    Callisto.Print(userobj, "\x000314#listlang    list language codes");
                if (userobj.Level >= CmdLevelManager.GetLevel(Cmd.translate))
                    Callisto.Print(userobj, "\x000314#translate <user_id> <lang_id> <lang_id>     translate text");
                if (userobj.Level >= CmdLevelManager.GetLevel(Cmd.untranslate))
                    Callisto.Print(userobj, "\x000314#untranslate <user_id>     untranslate text");
                if (userobj.Level >= CmdLevelManager.GetLevel(Cmd.banstats))
                    Callisto.Print(userobj, "\x000314#banstats     list session bans info");
                if (userobj.Level >= CmdLevelManager.GetLevel(Cmd.link))
                    Callisto.Print(userobj, "\x000314#link <hashlink>     link to another chatroom");
                if (userobj.Level >= CmdLevelManager.GetLevel(Cmd.unlink))
                    Callisto.Print(userobj, "\x000314#unlink     finished link session");
                if (userobj.Level >= CmdLevelManager.GetLevel(Cmd.linkinfo))
                    Callisto.Print(userobj, "\x000314#linkinfo     details of linked room");
            }

            if (userobj.Level == AdminLevel.Host)
            {
                Callisto.Print(userobj, "\x000314#status <message>     change host status in room info");
                Callisto.Print(userobj, "\x000314#roominfo <on or off>     enable room info");
                Callisto.Print(userobj, "\x000314#vroom <lock or unlock>    lock or unlock vroom");
                Callisto.Print(userobj, "\x000314#cbans     clear all ban lists");
                Callisto.Print(userobj, "\x000314#addautologin <user_id> <1-3>     add a new admin filter");
                Callisto.Print(userobj, "\x000314#remautologin <admin_id>     remove an admin filter");
                Callisto.Print(userobj, "\x000314#autologins     list all admin filters");
                Callisto.Print(userobj, "\x000314#grant <user_id> <1-3>     add temporary admin");
                Callisto.Print(userobj, "\x000314#ungrant <user_id>     remove temporary admin");
                Callisto.Print(userobj, "\x000314#loadmotd     reload the motd");
                Callisto.Print(userobj, "\x000314#hostclone <user_id> <message>     discreet clone");
                Callisto.Print(userobj, "\x000314#hostkill <user_id>     discreet kick");
                Callisto.Print(userobj, "\x000314#hostban <user_id>     discreet ban");
                Callisto.Print(userobj, "\x000314#hostunban <ban_id or \"name\">     discreet unban");
                Callisto.Print(userobj, "\x000314#hostcbans     discreet cbans");
                Callisto.Print(userobj, "\x000314#hostmuzzle <user_id>     discreet muzzle");
                Callisto.Print(userobj, "\x000314#hostunmuzzle <user_id>     discreet unmuzzle");
                Callisto.Print(userobj, "\x000314#enableadmins     enable room commands");
                Callisto.Print(userobj, "\x000314#disableadmins     disable room commands");
                Callisto.Print(userobj, "\x000314#history <on or off>     show chat history");
            }
        }
    }
}
