﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace CallistoX
{
    static class WebResults
    {
        public static ThreadSafeList<WebResult> Results { get; set; }

        static WebResults()
        {
            Results = new ThreadSafeList<WebResult>();
        }
    }

    class WebResult
    {
        public String Text { get; set; }
        public ushort Vroom { get; set; }
        public bool IncludeLink { get; set; }

        public WebResult(ushort vroom, String text)
        {
            this.Vroom = vroom;
            this.Text = text;
            this.IncludeLink = false;
        }

        public WebResult(ushort vroom, String text, bool link)
        {
            this.Vroom = vroom;
            this.Text = text;
            this.IncludeLink = link;
        }
    }
}
